c     Raytrace.F  begins                    ---------------------------|
c
c     DoRay     begins                      ---------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE DoRay(iDoRay)
#include "Implic.inc"
      EXTERNAL RayIni, PredcLSC, EZfini
#include "params.inc"
#include "dielec.inc"
#include "tscunits.inc"
#include "Doflags.inc"
#include "PlPr.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
      INTEGER iry, ity, ipy, RayIniErr, iFillPsi, iDoRay, iErrCount
      iFillPsi =1
c     iDoRay : if it has a value 1 thru nrays==npols*ntors
c              then trace just the ray with that index
c              if it is any other value, then trace all rays
c
      iErrCount = 1
      iry = 0
      do 70 ity =1,ntors
      do 69 ipy =1,npols
        iry=iry+1
        iray = iry
        if ( iDoRay .eq. iray .or.
     ^       iDoRay .lt. 1    .or. 
     ^       iDoRay .gt. nrays     ) then
          mstpLH = nfreq
          call RyZnInit    !! 9sep 93
          iplt = 0
          lnewray = iray
          enpar = ntor (ity)
          enpol = npol (ipy)
          izone = 1
          call RayIni  (RayIniErr)
          if (RayIniErr .ge. 1) then
             iErrCount = iErrCount+1
             go to 69
          endif
          call PredcLSC
c         call LSCPause
          if(PlFlg(RAYPL) .eq. TRUE)then
             call PlRay(iFillPsi)
                iFillPsi=0
                if (iError .gt. 0)  return
          endif
        endif
 69   continue
 70   continue
      if (iErrCount .ge. ntors*npols) then 
        iError = 1
        call LSCtrace('RayIni')
      endif
      return
      END
c                                                                      |
c                                                                      |
c     DoRay     ends                        ---------------------------|
c
c     PredcLSC begins                       ---------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE PredcLSC
#include "Implic.inc"
      EXTERNAL RungeLSC, ftion, prtout
C     These integer variables allow stopping the
C     integration when some condition is met.
C     Lstop    is meant for serious conditions
C              such as going out of bounds.
c     The integer with which PrtOut is called ... call PrtOut(Lprint)...
c     Lprint   tells whether to force printing, or wait till nfreq
c              steps go by.  Lprint=1  --> force print
c                            Lprint=0  --> advance counter and decide
c     The include statements are to catch: begin,h,nstep,lstop,
c     and especially NEQS and NEQSP1
#include "params.inc"
#include "dielec.inc"
#include "RayWrk.inc"
#include "PlPr.inc"
#include "tscunits.inc"
      INTEGER i,j, jstart, BoundsEr, iBndsErr, nBndsErr
      REAL    yok(NEQSP1), thi, tho
      Real pc(NEQS), c(NEQS),p(NEQS),dumy(NEQS)
      Real k1,k2,k3,k4,k5,k6,k7,k8,k9,k10
      DATA      k1,         k2,        k3,         k4,          k5,
     ^          k6,         k7,        k8,         k9,          k10 /
     ^  2.65277776, -1.4861111, 1.5138888,  -.34722222,  .94266666,
     ^   .34722222,  1.2638888,  .59722222,  .125     ,  .05733333  /
      DATA  iBndsErr, nBndsErr / 0 , 25 /
      jstart = 4
      iscatplt = 1
 10   continue
      do 20 i = 1, NEQS
      pc(i) = 0.0
 20   continue
      BoundsEr = 0
      lstop = 0
      call RungeLSC(BoundsEr)
      if (BoundsEr .ne. 0 ) then
        call LSCendr(' Cant recover in PredcLSC')
        return
      endif
            
      call KeepGood(y, yok, NEQSP1)

      do 80 j = jstart, nstep
      call KeepGood(y, yok, NEQSP1)
      if ( iError .ge. 1 ) return
      if ( lstop .eq. 1) go to 90
      y(NEQSP1) = begin + float(j)*HstpLH
      do 30 i=1,NEQS
      dumy(i) = (y3(i)+y3(i) + y2(i))/3.
      p(i)=dumy(i)+HstpLH*(k1*f(i)+k2*f3(i)+k3*f2(i)+k4*f1(i))
      y1(i)=y2(i)
      y2(i)=y3(i)
      y3(i)=y(i)
c modify
      y(i)=p(i)-k5*pc(i)
      f1(i) = f2(i)
      f2(i) = f3(i)
      f3(i) = f(i)
30    continue
      call ftion(BoundsEr)
        if(BoundsEr .ne. 0) go to 100
      do 40 i = 1,NEQS
c correct
      c(i)= dumy(i)+HstpLH*(k6*f(i)+k7*f3(i)+k8*f2(i)+k9*f1(i))
      pc(i) = p(i)-c(i)
c final
      y(i) = c(i)+k10*pc(i)
40    continue
 
60    call prtout(0)
70    call ftion(BoundsEr)
        if(BoundsEr .ne. 0) go to 100
80    continue
      return
90    call prtout(1)
      return
c     -                                 Attempt to recover from ray error,
c     -                                 most likely running out of bounds,
c     -                                 by specular reflection off the last
c     -                                 good set of values.
 100  continue
      jstart = j
c      if (EnhcNpar .eq. TRUE) then
c        call BounShft(yok, y, NEQSP1, NparEnhc)
c      else
c        call BounceIt(yok, y, NEQSP1)
c      endif
      if ( ScatKdeg .gt. 0.001) then
        call BounShft(yok, y, NEQSP1, ScatKdeg, thi, tho)
        inciThet(iscatplt) = thi/3.1416*180.
        scatThet(iscatplt) = tho/3.1416*180.
        iscatplt=iscatplt+1
        if (iscatplt .gt. NPLTDIM) iscatplt=NPLTDIM

      else
        call BounceIt(yok, y, NEQSP1)
      endif

      iBndsErr = iBndsErr + 1
      if (iBndsErr .ge. nBndsErr) then
        iBndsErr = 0
        write(nLSCcomm, '(
     ^  '' Rays out of bounds; recovered'',i4,'' times'')') nBndsErr
      endif
      goto 10
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE RungeLSC(BoundsEr)
#include "Implic.inc"
      EXTERNAL ftion, prtout
#include "params.inc"
#include "dielec.inc"
#include "RayWrk.inc"
#include "PlPr.inc"
 
      INTEGER ia,ib,ic,  i,k
      INTEGER BoundsEr
      REAL q(NEQSP1),a(4),b(4),c(4)
      Real dum
      DATA (a(i),i=1,4)/ 0.5, 0.29289322, 1.70710675, 0.1666667 /
      DATA (b(i),i=1,4)/ 2. , 1.        , 1.        , 2.        /
      DATA (c(i),i=1,4)/ 0.5, 0.29289322, 1.70710675, 0.5       /
      f(NEQSP1) = 1.
      q(NEQSP1) =0.
      call ftion(BoundsEr)
        if(BoundsEr .ne. 0) go to 100
      do 10 i=1,NEQS
      y1(i) = y(i)
      f1(i) = f(i)
10    q(i)=0.
 
      do 40 ia=2,4
      do 13 ib=1,4
12    call ftion(BoundsEr)
        if(BoundsEr .ne. 0) go to 100
      do 13 ic=1,NEQSP1
      dum = a(ib)*(f(ic)-b(ib)*q(ic))
      y(ic) = y(ic) + HstpLH*dum
      q(ic) = q(ic) + 3.*dum-c(ib)*f(ic)
13    continue
      k = ia-1
      call prtout(1)
15    go to (20,30,40) k
20    do 22 ic= 1,NEQS
      f2(ic) = f(ic)
      y2(ic) = y(ic)
22    continue
      go to 40
30    do 35 ic=1,NEQS
      y3(ic) = y(ic)
      f3(ic) = f(ic)
35    continue
40    continue
      return
 100  continue
      BoundsEr = 1
      call LSCwarn(' Boundary error in RungeLSC')
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE KeepGood(y, yok, n)
#include "Implic.inc"
      INTEGER n, i
      REAL    y(n), yok(n)
      do 10 i=1,n
        yok(i) = y(i)
 10   continue
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE BounceIt (yok, y, n)
#include "Implic.inc"
      INTEGER n,i
      REAL yok(n), y(n)
      REAL    r,z,   psi, Br, Bz, RBphi, omc, Tee, pe2, pi2, aio, ael
      REAL    B2, crr, crz, czr, czz, KrNew, KzNew
c     Go back to the last ok solution point, and re-arrange kr and kz
c     such that k \dot B is unchanged but k \cross B changes sign.  Then
c     put this new information into the starting condition for y.
c     y(1)  y(2)  y(3)  y(4)  y(5)  y(6)
c      r     z    phi   k_r   k_z    n
c
      

      r   = yok(1)
      z   = yok(2)
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)

      B2  =  Br*Br + Bz*Bz
      crr = (Br*Br - Bz*Bz)/B2
      czz = - crr
      crz = 2. *  Br*Bz/B2
      czr = crz

      KrNew = crr * yok(4) + crz * yok(5)
      KzNew = czr * yok(4) + czz * yok(5)
      
      yok(4) = KrNew
      yok(5) = KzNew
      do 10 i=1,n
        y(i) = yok(i)
 10   continue
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE BounShft (yok, y, n, ScatKdeg, thi, tho)
#include "Implic.inc"
      INTEGER n,i
      REAL    yok(n), y(n), ScatKdeg, tauFWP
      REAL    r,z,   psi, Br, Bz, RBphi, omc, Tee, pe2, pi2, aio, ael
      REAL    Bph, kro, kzo, kpho, thi, tho
      r   = yok(1)
      z   = yok(2)
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      Bph = RBphi/r
      tauFWP =  (ScatKdeg*3.1416/180.0)**2
      call GetKscat( yok(4), yok(5), yok(6)/r, Br, Bz, Bph, tauFWP, 
     ^                  kro, kzo,      kpho, thi, tho )
      yok(4) = kro
      yok(5) = Kzo
      yok(6) = kpho*r
      do 10 i=1,n
        y(i) = yok(i)
 10   continue
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE GetKscat( kri, kzi, kphi, Br, Bz, Bph, tau, 
     ^                     kro, kzo, kpho, thi, tho )
#include "Implic.inc"
c     Get K scattered by fluctuations.
c     Copyright 1993 by F. W. Perkins, H. Takahashi, D. W. Ignat, & E. J. Valeo
c     Given the initial k in r,z,phi space and the B at that point
c     return the out k 
c     by transforming to a space in grad psi, transverse, and parallel
c     referred to as                  rr    ,   tt      ,     ll
c     rotating the k randomly around the ll (field) direction thus preserving
c     k_parallel (kll)  and k_perp (kperp) but not k-phi 
c     The parameter tau controls the randomness.  
c     If tau is large then the scattered k peaks perpendicular to the wall
c     If tau is small, then the reflection is specular, without randomization
c
c     The angle is measured with respect to the tt direction

c      tt ( perp to B and to grad psi )
c      ^
c      |  theta(i)
c      |          .
c      |     .                           (parallel to B directionout of paper)
c      | .
c      +------- >  rr (grad poloidal flux
c
c     Following Perkins the Prob(ability) of scattering from thetai to theta is
c
c          Prob ~ sin(theta) exp{ - (theta-thetai)^2/tau }
c     and one forms the integral 
c          ProbIntl(theta,thetai,tau) which is zero at theta=0 and 1 at theta=PI
c     so that if a random number is chosen between 0 and 1, a unique angle
c     is determined.  If tau is big, PI/2 is most likely; if tau is small
c     then thetai is most likely
c
c
c     IMPLICIT NONE
      CHARACTER*40 MyString
      INTEGER i,j,  isimp, ifirst, NumThets
      INTEGER ithetai, itheta
      INTEGER idum
      REAL    kri, kzi, kphi
      REAL    kro, kzo, kpho, thi, tho 
      REAL    krr, ktt, kll, kperp, signth
      REAL    ktoti, ktoto, ktott
      REAL    Br, Bz, Bph, Bp, B, tau
      REAL    TAUMAX, TAUMIN, tauold, thetai, dtheta
      REAL    cosalph, sinalph, cosbeta, sinbeta, simp(2)
      REAL    PI, PIby2, SMALL, ERR
      REAL    random
      REAL    ran3
      PARAMETER (NumThets=101)
      PARAMETER (TAUMAX=100.0, TAUMIN=1.0e-05)
c     if  exp{ - (th_out_deg-th_in_deg)^2/del_th_deg^2 }
c     and exp{ - (th_out_rad-th_in_rad)^2/tauFWPerkins }
c     then    (del_th_deg,tauFWP) = (0.1deg,2.e-6) (1.0deg,3e-4) (360deg,40.0)
      REAL    ProbIntl(NumThets, NumThets),theta(NumThets)
      REAL    clevelin(20), tauDEG
      DATA    ifirst, SMALL, ERR / 1, 1.0e-25, 1.0e-5 /
      DATA    simp(1), simp(2) / 4.00 , 2.00 /

      real    RE41
      REAL    
     ^        ZERO, ONE
      DATA    ZERO, ONE/
     ^         0.0, 1.0/

c     If first call, set up PI and theta array
c     Also if first call set the ProbIntl to the result for large tau
      if (ifirst .eq. 1) then
        ifirst = 0
        PIby2  = asin(1.00)
        PI     = PIby2 + PIby2
        dtheta = PI / float(NumThets - 1)
        do 10 i = 1,NumThets
          theta(i) = dtheta * float(i-1)
            ProbIntl(i,1) = 0.5 * ( 1. - cos (theta(i)) )        

          do  9 j = 2,NumThets
            ProbIntl(i,j) = ProbIntl(i,1)
 9        continue
 10     continue
        tauold = TAUMAX
      endif
c
c
c     Fill the array of ProbIntl unless the values from the last call
c     or from the first call set up are ok
c
      if ( tau .ne. tauold .and.
     ^   (tau .le. tauold .or. tauold .ne. TAUMAX) ) then

        do 20 j=1,NumThets
          ProbIntl(1,j) = ZERO   
 20     continue

        do 25 j=1,NumThets
          thetai = theta(j)
          do 24 i=2,NumThets
            isimp = mod(i,2) + 1
            ProbIntl(i,j) = ProbIntl(i-1,j) + 
     ^       simp(isimp)*sin(theta(i))*exp(-(theta(i)-thetai)**2/tau)
 24       continue
 25     continue

        do 30 j=1,NumThets
        do 30 i=2,NumThets
          ProbIntl(i,j) =  ProbIntl(i,j)/ProbIntl(NumThets,j)
 30     continue

cccc  Contour plot begins
c     ------------------------------------------------------------------
c     kclev1: >0 --> clevelin contains levels to be used; 
c                    dots for index less than kclev2; 
c                    solid for index greater or equal kclev2
c     kclev1: =0 --> first contour at clevelin(1) with
c                    next one up by clevelin(2), and so on and so on
c     kclev1: <0 --> rcontr to choose -kclev1 equally spaced values between
c                    clevelin(1) and clevelin(2)
c     clevelin:      array of contour levels; this is output if kclev1<0
c     kclev2:        separates dots from solid lines
c     call EZrcon(ix1(1),ix2(1), jy1(1), jy2(1),
c    ^             xa,    xb,     ya,     yb   , 
c    ^  kclev1,clevelin,kclev2,
c    ^  PsiContr,                        
c    ^  i1stdim,                         
c    ^  xAry, ixmin, ixmax, ixstep,      
c    ^  yAry, jymin, jymax, jystep )     
      do i=1,9
      clevelin(i)=0.1*float(i)
      enddo
      call EZrcon(150,   500,  250,    600, 
     ^            0.0,   3.2,  0.0,    3.2,
     ^  9,clevelin,5,
     ^  ProbIntl,
     ^  NumThets,
     ^  theta, 1, NumThets-1, 1,
     ^  theta, 1, NumThets-1, 1)
      call EZwrit( 150, 150,
     ^            'ProbIntl; theta_in ordinate$',0,0)
      call EZwrit( 150, 125,
     ^            'theta_out abcsissa(radians)$',0,0)
      tauDEG = sqrt(tau)*180./3.14
      write(MyString,'(''tauDEG, tauFWP: '',
     ^                   f5.1,1x,1pe9.2,''$'')')tauDEG,tau
      call EZwrit( 150, 100,MyString,0,0)
      call EZfini(0,0)
      call MkGrfLst   (' ProbIntl plot ')
cccc  Contour plot ends
      endif
c     .
c     .                                 Here is the normal starting point !!
c     .
      Bp  = sqrt(Br*Br + Bz*Bz) + SMALL
      B   = sqrt(Br*Br + Bz*Bz + Bph*Bph) + SMALL
      cosalph = abs(Bph)/B
      sinalph =     Bp  /B
      cosbeta =     Br  /Bp
      sinbeta =     Bz  /Bp

      krr =         sinbeta*kri -         cosbeta*kzi +    ZERO*kphi
      ktt = cosalph*cosbeta*kri + cosalph*sinbeta*kzi - sinalph*kphi
      kll = sinalph*cosbeta*kri + sinalph*sinbeta*kzi + cosalph*kphi

      kperp = sqrt(krr*krr + ktt*ktt)
      ktott = sqrt(krr*krr + ktt*ktt + kll*kll)
      if ( krr  .lt. ZERO ) then
        signth = - 1.00
        krr    = abs(krr)
        thetai = asin (krr/kperp)
        if (ktt .lt. ZERO ) thetai = PI - thetai
      else
        signth = + 1.00
        thetai = asin (krr/kperp)
        if (ktt .lt. ZERO ) thetai = PI - thetai
      endif
      RE41 = thetai/dtheta
      ithetai = ifix(RE41) + 1 
c     ithetai = ifix(thetai/dtheta) + 1 
      thi = theta(ithetai)
c
      if (tau .lt. TAUMIN) then
        krr = -signth*krr
        ktt = +       ktt
        tho = thi
      else
c
        idum=1
        random = ran3(idum)
c
        do 50 i=2,NumThets
          itheta = i
          if (ProbIntl(i,ithetai) .gt. random ) go to 51
 50     continue
 51     continue
        
         
        krr = -signth*kperp* sin(theta(itheta))
        ktt =         kperp* cos(theta(itheta))
        tho = theta(itheta)

      endif

      kro =  sinbeta*krr + cosalph*cosbeta*ktt + sinalph*cosbeta*kll
      kzo = -cosbeta*krr + cosalph*sinbeta*ktt + sinalph*sinbeta*kll
      kpho=     ZERO*krr - sinalph*        ktt + cosalph*        kll

      ktoti = sqrt(kri*kri + kzi*kzi + kphi*kphi)
      ktoto = sqrt(kro*kro + kzo*kzo + kpho*kpho)
c
c     Take this out June 2000, below
c      if ( abs(ktoti-ktoto) .gt. ERR*ktoti .or.
c     ^     abs(ktoti-ktott) .gt. ERR*ktoti .or.
c     ^     abs(ktott-ktoto) .gt. ERR*ktoto  ) then
cc       call LSCpause
c        write(6,'(''GetKscat error; ktoti, ktoto, ktott:'',
c     ^                           3(1x,1pe10.3))') ktoti, ktoto, ktott
cc       call LSCpause
c      endif
c     Take this out June 2000, above
c
      tauold = tau
      return
      END
c
c     -----------------------------------------------------------------
c
      REAL FUNCTION ran3(idum)
c     Transcribed 1993 by D. W. Ignat
c     References: 
c     W. H. Press et al, Numerical Recipes in Fortran, p199
c     D. Knuth, Seminumerical Algorithms, Vol 2 of The Art of Computer
c          Programming
c     Returns a uniform random deviate between 0.0 and 1.0.
c     Set idum to any negative value to initialize or reinitialize the
c     sequence.
c     Substitute the CCCommented lines for the ones following to
c     render the routine entirely floating point.
#include "Implic.inc"
      INTEGER idum, MBIG, MSEED, MZ, iff, mj,mk
      INTEGER i,ii,k, inext, inextp
c     .                                 55 dimension is special; no changes!
      INTEGER ma(55)
      REAL    FAC
CCC   IMPLICIT REAL*4(M)
CCC   PARAMETER (MBIG=4000000.,   MSEED=1618033., MZ=0.,FAC=1./MBIG)
      PARAMETER (MBIG=1000000000, MSEED=161803398,MZ=0, FAC=1./MBIG)
      DATA iff /0/
c                                       Initialize
      if(idum .lt. 0 .or. iff .eq. 0) then
        iff=1
c     .                                 Initialize ma(55) using the seed idum
c     .                                 and the large number MSEED
        mj=MSEED-iabs(idum)
        mj=mod(mj,MBIG)
        ma(55)=mj
        mk=1
c     .                                 Now initialize the rest of the table
c     .                                 in a slightly random order
c     .                                 with numbers that are not especially
c     .                                 random
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk .lt. MZ) mk=mk+MBIG
          mj=ma(ii)
 11     continue
c     .                                 We randomize them by 
c     .                                 'warming up the generator'
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i) .lt. MZ) ma(i)=ma(i)+MBIG
 12       continue
 13     continue
c     .                                 Prepare indices for our first 
c     .                                 generated number.   The constant 31
c     .                                 is special...see Knuth
        inext=0
        inextp=31
        idum=1
      endif
c
c     .                                 Here is where we start usually
c     .                                 Increment inext, wrap around 56 to 1
      inext=inext+1
      if(inext .eq. 56)inext=1
      inextp=inext+1
c     .                                 Ditto for inextp
      if(inextp .eq. 56)inextp=1
c     .                                 Now generate a new random number
      mj=ma(inext)-ma(inextp)
c     .                                 Be sure it is in the range
      if(mj .lt. MZ)mj=mj+MBIG
c     .                                 Store it, and output ran3
      ma(inext)=mj
      ran3=mj*FAC
      return
      END
c
c     -----------------------------------------------------------------
c
c
c
c                                                                      |
c                                                                      |
c     PredcLSC ends                         ---------------------------|
c
c     eps -- dielectric tensor              ---------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE eps ( r, z, kpar2, kper2 )
#include "Implic.inc"
      EXTERNAL plasma2d, bsi0, bsi1
#include "params.inc"
#include "MKSetc.inc"
#include "PIetc.inc"
#include "dielec.inc"
c     INCLUDE 'RayBins.inc'
#include "RayWrk.inc"
      REAL
     ^    r,z,kpar2,kper2,
     ^    HUGE,veow2,elam,elamc,emli0,emli1,
     ^    exy0,bsi0,bsi1,
     ^                        psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
 
      DATA HUGE / 1.0e+30 /
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      If ( psi .ge. HUGE ) return
      ecyc  = omc/fghz
      ecyc2 = ecyc*ecyc
      epsq  = pe2/fghz**2
      ipsq  = pi2/fghz**2
      veow2 = 0.0445e-04*tee/fghz**2
      elamc = veow2/ecyc2
      elam  = elamc * Kper2
c     This is the electron Lambda - - (Kper RhoE)^2
c     Now form the quantities exp(-elam) I0,1 (elam)
      emli0 = bsi0(elam)
      emli1 = bsi1(elam)
      epar  = 1. - epsq
      aion = aio/fghz**4
      aelc = ael
      eper = 1. + epsq/ecyc2  - ipsq
      eper = eper - kper2 * ( aion + aelc )
      exy0  = epsq/ecyc
      exy   = exy0
      return
 
      ENTRY epsdr  ( r, z, Kpar2, Kper2 )
c     derivatives of the dielectric tensor elements
c     by (k-perp)**2 ; (k-par)**2 ; (omega)**2
c     this last is multiplied by (omega**2)

      d11er = -(aion + aelc)
      d11ar = 0.
      d11w0 = ipsq + 2.*aion*kper2
 
      d12er = 0.
      d12ar = 0.
      d12w0 = -0.5*exy
 
      d33er = 0.
      d33ar = 0.
      d33w0 = epsq
      return

      END
c                                                                      |
c                                                                      |
c     eps ends                              ---------------------------|
 
 
c     FTION  function for integration       ---------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE ftion(BoundsEr)
#include "Implic.inc"
      EXTERNAL plasma2d, eps, epsdr
c     KdB   k \cdot B = ( k_r B_r + k_z B_z + (n/r) B_{\phi} )
c     KdK   k \cdot k = ( k_r^2   + k_z^2   + (n/r)^2 )
c     \p = \partial , the Greek for partial derivative
c     \R = {\bf r}  , the vector r
c     \K = {\bf k}  , the vector k
c     \abs{#1} = \mid #1 \mid , the absolute value
c     s  =  s       , the abs value of \R; ds = path length
c     D  = D(\R,\K,\omega) ; D = 0 is the dispersion relation
c     D  = Kper4 * Eper
c        + Kper2 * [ Qpar*(Epar+Eper) + woc2*Exy**2 ]  ! Kper2 * bb
c        +  Epar * [(Qpar )**2 - (woc2*Exy)**2 ]       ! Epar  * cc
c     bkb(3) = 0.5 \p k_{\parallel}^2 / \p (k_r,k_z,n)
c     per(3) = 0.5 \p k_{\perp}^2     / \p (k_r,k_z,n)
c     dRdwt  = -\frac{\p D/\p\K}{\omega \p D/\p\omega}
c     dKdwt  = +\frac{\p D/\p\R}{\omega \p D/\p\omega}
c     dsdwt  = \abs{dRdwt}
c     dRds   = dRdwt/dsdwt      == f(1,2,3)
c     dKds   = dKdwt/dsdwt      == f(4,5,6)
c     dwtds  = 1./dsdwt
c     wdDdw  = \omega \p D/\p \omega
c     DKpar ==  \p D/\p k_{\parallel}^2
c     DKper ==  \p D/\p k_{\perp}^2
c     Qpar = Kpar2 - woc2*Eper
c     QparE= \p Qpar/\p Kper2
c     QparA= \p Qpar/\p Kpar2
c     QparW= \p Qpar/\p \omega^2  \cdot \omega^2
 
      INTEGER BoundsEr
      REAL    DispRela
      REAL    KdB,KdK,  Kper2,Kper4,Kpar2
      REAL    Btot2, Qpar, QparE, QparA, QparW, bb, cc
      REAL    bkb(3), per(3), dRdwt(3), dKdwt(3),  dsdwt
      REAL    DR,DZ
      REAL    r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
 
 
#include "params.inc"
#include "tscunits.inc"
#include "MKSetc.inc"
#include "PIetc.inc"
 
#include "dielec.inc"
c     INCLUDE 'RayBins.inc'
#include "RayWrk.inc"
#include "ProfBody.inc"
#include "Doflags.inc"

c     DATA DR,DZ/-0.0005,0.0005/
      DATA DR,DZ/-0.0001,0.0001/

      r = Y(1)
      z = Y(2)
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      BoundsEr = 0
            If ( pe2 .le. pe2min     ) then
               BoundsEr = 1
c
c                 write(nLSCcom2,'(/,/,'' pe2 '', g11.4,1x, 
c     ^           ''.le.'',1x, g11.4,1x, ''in ftion '')')pe2, pe2min
c
               return
            endif
 
      Btot2 =  Br*Br + Bz*Bz + (RBphi/r)**2
      KdK = Y(4)**2 + Y(5)**2 + (Y(6)/R)**2
 
      KdB = Y(4)*Br + Y(5)*Bz + Y(6)/R/R *RBphi
      Kpar2 = KdB**2/Btot2
      Kper2 = KdK - Kpar2
      call eps   ( r, z, Kpar2, Kper2 )
      call epsdr ( r, z, Kpar2, Kper2 )
      bkb(1) = Br*KdB/Btot2
      bkb(2) = Bz*KdB/Btot2
      bkb(3) = rBphi*KdB/Btot2 /R/R
 
      per(1) = Y(4) - bkb(1)
      per(2) = Y(5) - bkb(2)
      per(3) = Y(6)/r**2 - bkb(3)
10    continue
      Kper4 = Kper2**2
      Qpar = Kpar2 - woc2*Eper
      QparE= -woc2*D11er
      QparA= 1. -woc2*D11ar
      QparW= -woc2*(Eper+D11w0)
 
      bb = Qpar*(Epar+Eper) + woc2*Exy*Exy
      cc = Qpar*Qpar - woc4*Exy*Exy
 
      denom = Kper4*D11w0
     1     + Kper2*(QparW*(Epar+Eper) + Qpar*(D33w0+D11w0)
     2     +        woc2*Exy*Exy + 2.*woc2*EXY*D12w0      )
     3     + cc*D33w0
     4     + Epar*(2.*Qpar*QparW -2.*woc4*Exy*Exy
     5            -2.*woc4*Exy*D12w0                 )
      denom = 2.*denom
      wdDdw = denom
 
      DKper = 2.*Eper*Kper2 + bb
     1      +  D11er *Kper4
     2      + Kper2*(QparE*(Epar+Eper) + Qpar*(D33er+D11er)
     3             + woc2*2.*Exy*D12er                      )
     4       + Epar*(Qpar*QparE - woc4*Exy*D12er)*2.
     5       +D33er*cc
 
      DKpar = Kper4*D11ar
     1     + Kper2*(QparA*(Epar+Eper) + Qpar*(D33ar+D11ar)
     2     +       2.*woc2*Exy*D12ar   )
     3     + D33ar*cc
     4     + Epar*2.*(Qpar*QparA - woc4*Exy*D12ar )
 
      dRdwt(1) = -2.* ( DKper*per(1) + DKpar*bkb(1) )/denom
      dRdwt(2) = -2.* ( DKper*per(2) + DKpar*bkb(2) )/denom
      dRdwt(3) = -2.* ( DKper*per(3) + DKpar*bkb(3) )/denom
 
      dsdwt    = sqrt ( dRdwt(1)**2 + dRdwt(2)**2 + r*r*dRdwt(3)**2 )
 
      dKdwt(1) =(DispRela(Y(1)+DR,Y(2),     Y(4),Y(5),Y(6) ) -
     ^           DispRela(Y(1)-DR,Y(2),     Y(4),Y(5),Y(6) ) )
     ^                                                 /(2.*DR)/denom
      dKdwt(2) =(DispRela(Y(1),Y(2)+DZ,     Y(4),Y(5),Y(6) ) -
     ^           DispRela(Y(1),Y(2)-DZ,     Y(4),Y(5),Y(6) ) )
     ^                                                 /(2.*DZ)/denom
      dKdwt(3) = 0.
      f(1)     = dRdwt(1)/dsdwt
      f(2)     = dRdwt(2)/dsdwt
      f(3)     = dRdwt(3)/dsdwt
      f(4)     = dKdwt(1)/dsdwt
      f(5)     = dKdwt(2)/dsdwt
      f(6)     = 0.
      f(7)     = 1.      /dsdwt
      dDdkABS  = wdDdw  * dsdwt
      return
      END
c                                                                      |
c                                                                      |
c     FTION ends                            ---------------------------|
c
      SUBROUTINE WhchRoot (r, z, Kr, Kz, Kphi, NperFs, NperSl)
#include "Implic.inc"
#include "params.inc"
#include "MKSetc.inc"
#include "PIetc.inc"
#include "dielec.inc"
#include "RayWrk.inc"
      REAL    NperFs, NperSl, AAD1, BBD2, CCD4, B2m4AC
      REAL    r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      REAL    Kr, Kz, Kphi, Kpar2, Kper2, KdK
      REAL    Btot2, Qpar
c
      real    R41
      REAL    
     ^        ZERO, ONE
      DATA    ZERO, ONE/
     ^         0.0, 1.0/
c
      KdK  = Kr**2 + (Kz)**2 + (KPhi/R)**2
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      Btot2 =  Br**2 + Bz**2 + (RBphi/r)**2
      Kpar2 = ( Kr*Br + Kz*Bz + Kphi*rBphi/r/r )**2/Btot2
      Kper2 = KdK - Kpar2
 
      call eps ( r, z, Kpar2, Kper2 )
      Qpar = Kpar2 - woc2*Eper
      AAD1 = Eper
      BBD2 = ( (Epar+Eper)*Qpar + woc2*Exy**2 )/woc2
      CCD4 = Epar*( Qpar**2 - woc4*Exy**2 )/woc4
      B2m4AC = BBD2**2 - 4.*AAD1*CCD4
      NperFs = - BBD2 / (2.*AAD1)
      NperSl = NperFs
      if (B2m4AC .gt. 0.) then
        B2m4AC = sqrt(B2m4AC)/(2.*AAD1)
        NperFs = NperFs - B2m4AC
        NperSl = NperSl + B2m4AC
      endif
        
        NperFs = amax1(NperFs, ZERO)
        NperSl = amax1(NperSl, ZERO)
        NperFs = sqrt( NperFs)
        NperSl = sqrt( NperSl)
      return
      END

c     FUNCTION DispRela                     ---------------------------|
c                                                                      |
c                                                                      |
      REAL FUNCTION  DispRela (r, z, Kr, Kz, Kphi)
#include "Implic.inc"
#include "params.inc"
#include "MKSetc.inc"
#include "PIetc.inc"
#include "dielec.inc"
#include "RayWrk.inc"
      REAL    r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      REAL    Kr, Kz, Kphi, Kpar2, Kper2, KdK
      REAL    Btot2, Qpar
c
      KdK  = Kr**2 + (Kz)**2 + (KPhi/R)**2
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      Btot2 =  Br**2 + Bz**2 + (RBphi/r)**2
      Kpar2 = ( Kr*Br + Kz*Bz + Kphi*rBphi/r/r )**2/Btot2
      Kper2 = KdK - Kpar2
 
      call eps ( r, z, Kpar2, Kper2 )
      Qpar = Kpar2 - woc2*Eper
      D1 = Kper2**2*Eper
      D2 = Kper2*( (Epar+Eper)*Qpar + woc2*Exy**2 )
      D4 = Epar*( Qpar**2 - woc4*Exy**2 )
      DispRela  = D1  +  D2  +  D4
      return
      END
c                                                                      |
c                                                                      |
c     DispRela ends                         ---------------------------|
 
 
c     FUNCTION bsi0, bsi1                   ---------------------------|
c                                                                      |
c                                                                      |
      REAL FUNCTION bsi0(x)
#include "Implic.inc"
c
c     BsI0(x) = e^{-x} * I_0 (x)
c
 
      REAL TINY, HUGE, x, xx
      PARAMETER ( TINY = 1.0e-05 , HUGE = 20. )
      if ( x .lt. HUGE ) then
        bsi0 = 1.
        if ( x .lt. TINY ) return
        xx = x/2.
        xx = xx*xx
        bsi0 = exp(-x)*(1.+xx+xx**2/4.+xx**3/36.)
        return
 
      else
        bsi0 = 0.62e-04
        call LSCbigK( ' lambda too large in function bsi0')
      endif
 
      END
c                                                                      |
c                                                                      |
c                                                                      |
      REAL FUNCTION bsi1(x)
#include "Implic.inc"
c
c     BsI1(x) = e^{-x} * I_1 (x)
c
 
      REAL TINY, HUGE, x, xx
      PARAMETER ( TINY = 1.0e-05 , HUGE = 20. )
 
      if ( x .lt. HUGE ) then
        xx = x/2.
        bsi1 = exp(-x)*abs(xx)
        if ( x .lt. TINY ) then
          return
        else
          xx = xx*xx
          bsi1=bsi1*(1.+xx/2.+xx**2/12.+xx**3/144.)
          return
        endif
 
      else
        bsi1 = 0.16e-03
        call LSCbigK( ' lambda too large in function bsi1')
      endif
      END
c                                                                      |
c                                                                      |
c     bsi0, bsi1 end                        ---------------------------|
 
c
c
c                                                                      |
c                                                                      |
c     Raytrace.F  ends                      ---------------------------|
c
c     OLD code from BounShft saved Apr 93 temporarily
c     REAL    B2, Bp, crr, crz, crp, czr, czz, czp, cpr, cpz, cpp
c     REAL    KrNew, KzNew, KpNew
c     Go back to the last ok solution point, and re-arrange kr and kz
c     such that k \dot B is enhanced by "NparEnhc" (of order 1.1)
c     and a new k \cross B changes sign, and increases similarly;
c     put this new information into the starting condition for y.
c     This is BOUNcing the ray with a SHiFT of n_parallel
c
c     Vector algebra shows that, in order to preserve k_\parallel
c     and reverse the sign of k_\perp, an old vector k becomes a new
c     vector k' are related as follows:
c
c         \vec{k'} = - \vec{k} + 2 \vec{B} (k \dot B)/B^2
c
c     The integration vector is given by
c       y(1)  y(2)  y(3)  y(4)  y(5)  y(6)
c        r     z    phi   k_r   k_z    n
c
c      Bp  = RBphi/r
c      B2  =  Br*Br + Bz*Bz + Bp*Bp
c
c      crr = (Br*Br - Bz*Bz - Bp*Bp)/B2
c      czz = (Bz*Bz - Br*Br - Bp*Bp)/B2
c      cpp = (Bp*Bp - Br*Br - Bz*Bz)/B2
c      crz = 2. * Br*Bz/B2
c      crp = 2. * Br*Bp/B2
c      czp = 2. * Bz*Bp/B2
c      czr = crz
c      cpr = crp
c      cpz = czp
c
c      KrNew = crr * yok(4) + crz * yok(5) + crp * yok(6)/r 
c      KzNew = czr * yok(4) + czz * yok(5) + czp * yok(6)/r
c      KpNew = cpr * yok(4) + cpz * yok(5) + cpp * yok(6)/r
c
c      KrNew = NparEnhc * KrNew
c      KzNew = NparEnhc * KzNew
c      KpNew = NparEnhc * KpNew
c     end temp saved code






