c     jrf.F begins -----------------------------------------------------
c     .                                                                |
c     .                                                                |
c     Copyright 1991 by E. J. Valeo, C. F. F. Karney and N. J. Fisch,
c     Princeton University Plasma Physics Laboratory.
c     Ref: Current in wave-driven plasmas, by CFFK and NJF, Physics of
c     Fluids <29> pp 180-192 (1986).  See esp. eqn. 21b.
c     In constructing units, the rest of the code has velocities normalized
c     to c, and f contains a density in cm^{-3}.  
c     Dql has a c^2 taken out of it.
c     E is in v/m we assume.
c     \Gamma   = n_e q^4     \ln \lambda / (4 \pi \epsilon_0^2 m^2)
c              = n_e q^4 c^4 \ln \lambda \mu_0/(4\pi) \mu_0 / m^2
c                 with units of velocity^3 / time
c     v_r      = -sign(qE) \sqrt{m\Gamma/\abs(qE)}
c                 where q has the sign of the electron charge = - 1.6e-19
c                 and the electrons run away in the negative direction if
c                 v_r is positive
c     v_{norm} = \abs(v_r) / c
c              = sqrt ( \Gamma / \abs(qE/m) ) / c
c              = sqrt ( n/E q^3/m c^2 lnLambda mu_0 (mu_0/4PI) )
c                 dimensionless, in units of c
c     gmrun    = n_e q^4 ln(Lambda) / ( 4 PI eps_0^2 m_e^2 )          /  c^3
c              = n_e q^4 c^1 / m_e^2 * lnLambda * (mu_0/(4PI))*mu_0
c                 with units of time^{-1}
c
c     nuRuna   = gmrun/vnorm^3
c                 with units of time^{-1}
c     NeAry in cm^{-3}
c     gmrun in s^{-1}
c     nuRuna in s^{-1}
c     js in ampere/m^2
c     dfdv in cm^{-3}
c     dlnJdlnE = dJ/dE * (E/J) is dimensionless
c     and can be shown for small E (E is the E_{dc}) to be approximately
c     eE_{dc}/(m Gamma) * v_phase^2 * (1/(2 \mu)) ( (2+Z+3\mu^2)/(3+Z) )
c     =~ eE_{dc} / lnLamba /n_\parallel^2 / 
c                  [ e^2/(4\pi\epsilon_0 c^2/\omega_p^2)] * Order(1)
c
c     ------------------------------------------------------------------
c
c     Keeping the signs straight is a problem.  We say that positive
c     phase velocity tends to drive current in the supportive, or correct
c     direction.  Positive current drive.  Thus, presumably, the Edc
c     is also in the positive direction.  Electrons tend to run away
c     and be accelerated in the opposite direction.  Thus for positive
c     electron velocity which goes with positive phase velocity, the 
c     normalized   u \equiv v/v_r is negative, and the mu for this positive
c     v is negative.
c
c     v  E      u    mu
c     +  +      -     -
c     -  +      +     +
c     +  -      +     +
c     -  -      -     -
c
c     Code is written with the presumtion of E positive and mu minus
c     for positive velocity and mu plus for negative velocity.  If
c     E is negative, the quantitiy muminus becomes +1; muplus becomes -1
c
c     ------------------------------------------------------------------
c     
c     Getting jrf and the dc electric field to be self consistent
c     is a problem.  This fragment from TSC concerns the iteration:
c     .
c      subroutine curdrive ! TSC Code Fragment to write lhcdoua
cc
cc.....define quantities needed for current drive
cc.....(neutral beam and bootstrap current)
cc
c      include 'clinam.i'
c      include 'scr3.i'
c      include 'saprop.i'
c      data ifstrt/0/
c      data ifircd/0/
cc
c      dimension wrat(ppsi),anucoll(ppsi),tauconf(ppsi),disedge(ppsi)
c      dimension floss(ppsi),tauf(ppsi),form(ppsi),ajavlho(ppsi)
c      dimension djdets2(ppsi),djdelhn(ppsi)
cc
c      ifircd=0
c      if(ilhcd.eq.0 .or. ifk.ne.2 .or. ifircd .ne. 0) go to 49
c      iouttsc(1:6) = 'tscout'
c      iouttsc(7:7) = isuffix(1:1)
c      open(nlhcd2,file=iouttsc,status='unknown',iostat=ios2)
c      ilhcdou(1:6) = 'lhcdou'
c      ilhcdou(7:7) = isuffix(1:1)
c      open(nlhcd,file=ilhcdou,status='unknown',iostat=ios11)
c   49 continue
cc
c
c........
cc
cc     set counter keeping track of LSC/TSC iterations
cc     
c      ICLH = 0
cc     re-cycle point if current is not well-converged
cc
c 1654 continue
c
c      call lhwrite
c      call lsc(bpowsmw,nlhcd,nlhcd2,nsc1,nout,nlhcdin,nterm,irayt
c     1        ,iplot,ierr)
c      iraytd = irayt
c      if(ierr.gt.0) ineg=45
c      if(ierr.lt.0) write(nout,1991) ierr
c 1991 format("LSC returned ierr=",i5)
c      if(ierr.lt.0) write(nterm,1991) ierr
c      if(ineg.ne.0) return
c      rewind nlhcd2
c      read(nlhcd2,1001) (powtsc(l),l=2,npsit)
c      read(nlhcd2,1001) (currtsc(l),l=2,npsit)
c      read(nlhcd2,1001) (djdetsc(l),l=2,npsit)
c      read(nlhcd2,1001) (djdets2(l),l=2,npsit)
c 1001 format(1p5e16.6)
c  651 continue
cc
c      powsum = 0.
c      cursum = 0.
c      do 653 l=2,npsi
c      powsum = powsum + powtsc(l)*vp(l)*dpsi
c      cursum = cursum + currtsc(l)*1.e4*vp(l)*dpsi/(tpi*xplas)
c  653 continue
cc     write(nout,9662)
cc     write(nout,9661) (powtsc(l),l=2,npsit)
cc     write(nout,9663)
cc     write(nout,9661) (currtsc(l),l=2,npsit)
cc     write(nout,9664)
cc     write(nout,9661) (djdetsc(l),l=2,npsit)
cc     write(nout,9665)
cc     write(nout,9661) (voltlp(l),l=2,npsit)
cc     write(nout,9666)
cc     write(nout,9661) (.5*udsv*(as(l)+as(l-1)),l=2,npsit)
c 9666 format(" udsv*as ")
c 9661 format(1p5e12.4)
c 9662 format(" powtsc")
c 9663 format(" currtsc")
c 9664 format(" djdetsc")
c 9665 format(" voltlp")
c      iplot=0
c      irayt=0
cc
cc
c      do 660 j=2,npsit
c      ajavlho(j) = ajavlh(j)
c      djdelh(j) = 0.
c      ajavlh(j) = currtsc(j)*1.e4*usdi
cc     if( abs(voltlp(j)) .ge. .01)
cc    1djdelh(j) = djdetsc(j)*ajavlh(j)*tpi / (voltlp(j)*usdv)
c      djdelh(j) = djdets2(j)*1.e4*usdi/(usdv)
c  660 continue
c      ajavlh(1) = ajavlh(2)
c      djdelh(1) = djdelh(2)
c      djdetsc(1) = djdetsc(2)
c      if(ifk.eq.1) go to 700
cc
cc     correct current by Newton's iteration
cc
c      AJAVLHM = 0.
c      do 710 j=2,npsit
c      aterm = .5*(etpara(j)+etpara(j-1))*xplas*djdelh(j)
c      if(aterm.lt.0) aterm=0.
c      fac = aterm / (1.+aterm)
c      ajnew = ajavlh(j) + fac*(ajavlho(j) - ajavlh(j))
c      ajavlh(j) = ajnew
c      AJAVLHM = amax1(AJAVLHM,abs(ajavlh(j)))
c      currtsc(j) = ajavlh(j) / (1.e4*usdi)
c  710 continue
c      ajavlh(1) = ajavlh(2)
c      currtsc(1) = currtsc(2)
cc     write(nout,9663)
cc     write(nout,9661) (currtsc(l),l=2,npsit)
cc
c      cursum2 = 0.
c      do 753 l=2,npsi
c      cursum2 = cursum2 + currtsc(l)*1.e4*vp(l)*dpsi/(tpi*xplas)
c  753 continue
c      write(nout,9660) kcycle,iraytd,bpowsmw,powsum,cursum,cursum2
c      write(nterm,9660) kcycle,iraytd,bpowsmw,powsum,cursum,cursum2
c 9660 format(" LSC:N=",i5," iraytd=",i2," ,powin,out,cur",
c     1     1p4e 9.1)
cc     
cc     see if the correction to the current is reasonably big,
cc     and if so, rewrite the equilibrium file and recall LSC; 
cc     but not more than 50 times
c      RATHLH = 0.
c      do 1770 j=2,npsit
c      DENOM = ABS(ajavlh(j))
c      IF(DENOM .LE. .01*AJAVLHM) GO TO 1770
c      RATHLH = amax1(RATHLH,ABS(ajavlh(j)-ajavlho(j))/DENOM)
c 1770 continue
c      write(nterm,4700) kcycle,iclh,rathlh
c 4700 format(i5,i3,1pe12.4)
c      IF(RATHLH .LE. 0.1) GO TO 700
c      ICLH = ICLH+1
cc
cc     under-relax to avoid oscillations in current
cc     
c      write(nout,1790) kcycle,iclh
c      do 1780 j=2,npsit
c      DENOM = ABS(ajavlh(j))
c      IF(DENOM .LE. .01*AJAVLHM) GO TO 1780
c      diff = (ajavlh(j)-ajavlho(j))/DENOM
c      if(abs(diff).le.0.1) go to 1780
c      write(nout,1781) j,ajavlh(j),ajavlho(j),voltlp(j),djdelh(j)
c     1     ,diff
c 1780 continue
c 1790 format(" kcycle=",i4,"  iclh=",i2,/,
c     1"  j      ajavlh     ajavlho      voltlp      djdelh diff")
c 1781 format(i3,1p6e12.4)
c      backa = 0.5
c      if(iclh.gt.10) backa = .25
c      if(iclh.gt.15) backa = .10
c      if(iclh.gt.25) backa = .05
c      DO 1700, J=2, NPSIT
c      AJAVLH(J) = AJAVLHO(J) + backa*( AJAVLH(J) - AJAVLHO(J) )
c 1700 CONTINUE
cc
c      IF(ICLH .LT. 50) GO TO 1654
c      INEG = 45
c  700 continue
c      ajavlh(npsit+1) = ajavlh(npsit)
c      djdelh(npsit+1) = djdelh(npsit)
c      djdetsc(npsit+1)= djdetsc(npsit)
cc
cc.....define surface centered arrays
c      do 720 j=1,npsit
c      ajavlh2(j) = .5*(ajavlh(j)+ajavlh(j+1))
c      djdetsc2(j) = .5*(djdetsc(j)+djdetsc(j+1))
c  720 continue
cc
c      return
cc
c  701 continue
c      do 702 j=1,npsit+1
c      powtsc(j) = 0.
c      currtsc(j) = 0.
c      djdetsc(j) = 0.
c      ajavlh(j) = 0.
c      djdelh(j) = 0.
c      ajavlh2(j) = 0.
c      djdetsc2(j) = 0.
c  702 continue
c      return
cc
c      end
c
c     ------------------------------------------------------------------
c
      SUBROUTINE VmaxCalc
#include "Implic.inc"
#include "params.inc"
#include "FeBins.inc"
#include "RayBins.inc"
#include "Jrf.inc"
      INTEGER ip,ir,iz,iv
      REAL    vl
      do  5   ip=1,NPSIDIM
        VparMaxN(ip)= -0.05
        VparMaxP(ip)= +0.05
 5    continue
c
      do 20   ir=1,nrays
        do 10 iz=1,nzones
        iv = ivind(iz,ir)
        ip = izind(iz,ir)
          if (iv .eq. 0 .or. ip .eq. 0) goto 15
        vl = vpar(iv)


        if(VparMaxP(ip) .lt. vl) VparMaxP(ip) = vl
        if(VparMaxN(ip) .gt. vl) VparMaxN(ip) = vl
 10   continue
 15   continue
 20   continue
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE JdepCalc
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "ProfBody.inc"
#include "PlPr.inc"
#include "Jrf.inc"
      INTEGER ip, ipLastRuna, iGotRuna, nGotRuna, iFillJray
      INTEGER nrLines
      CHARACTER*70 ErrMsg
      DATA nrLines / 0 /
      REAL
     ^        ZERO, ONE
      DATA    ZERO, ONE/
     ^         0.0, 1.0/


c
c     compute rf driven current given power dissipation vs vpar, psi
c
      call GetEdc(ZERO)
c     call GetEdc(0.0)
c                                       Fill array EdcAry
      call BrodCast(NPSIDIM * NVELDIM, Jray,    0.)
      call VmaxCalc
      nGotRuna = 0
      do 10 ip = 1, npsi
        call jnorm(ip)
c                                       set up normalization, 
c                                       tabulate u lookup values
c
c     .                       
c     .                                 This is based on figure 2 of the 
c     .                                 Karney Fisch paper.  It shows that
c     .                                 if you are trying to drive current in
c     .                                 cooperation with the electric field
c     .                                 at v/vrun you have had it.  If trying
c     .                                 to drive against the electric field
c     .                                 you can go up to v/vrun of 2 before
c     .                                 runaways take over.
        if (EdcAry(ip) .ge. 0. ) then
          vnormPos(ip) = VparMaxP(ip)/vnorm /(1.0)
          vnormNeg(ip) = VparMaxN(ip)/vnorm /(2.0)
        else
          vnormPos(ip) = VparMaxP(ip)/vnorm /(2.0)
          vnormNeg(ip) = VparMaxN(ip)/vnorm /(1.0)
        endif

        vnormNOK(ip) = max0(int(vnormPos(ip)),
     ^                 iabs(int(vnormNeg(ip))))

c
c     .                                 compute jrf
        iFillJray = 1
        call mkj(ip,js(ip), iGotRuna, iFillJray)
c     .                                 Report if a runaway problem
c        
c
        if (iGotRuna .ge. 1) then
          nGotRuna = nGotRuna + 1
          ipLastRuna = ip
        endif

c     .                                 compute d/dt {n_runa; J-runa}
c     .                                 as in eqn (20) and (21c) of
c     .                                 Karney Fisch paper.  Aug 93
        call ddtNrnJrn ( ip,nRunDot(ip), jRunDot(ip), vRunIdx(ip) )


 10   continue
c
        if (nGotRuna .ge. 1) then
          write(ErrMsg,
     ^     '(1x,i4,'' Rway shells; last at ip='',i3)')
     ^       nGotRuna, ipLastRuna
          call LSCwarn(ErrMsg)
        endif
c!           call JrfDiagn was once here...seemed to double the graphs
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE JsplCalc
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "ProfBody.inc"
#include "Jrf.inc"
      INTEGER ip,iFillJray, iGotRuna
      REAL    jd
      DATA    iFillJray /0/
      REAL    ZERO
      DATA    ZERO/
     ^         0.0/
c     jd      current driven with the E field incremented by dEdcAmnt
c     compute rf driven current given power dissipation vs vpar, psi
c

      call GetEdc(dEdcAmnt)
c     .                                 Fill array EdcAry with dEdcAmnt over
c     .                                 the actual Edc supplied from TSC
c     .                                 dEdcAmnt is assigned in block data
      do 10 ip = 1, npsi
        call jnorm(ip)
c     .                                 set up normalization, 
c     .                                 tabulate u lookup values; 
c     .                                 These depend on Ez
        call mkj(ip,jd, iGotRuna,iFillJray )
c     .                                 compute jrf driven, jd
        jsp(ip) = jd
 10   continue
      call GetEdc(ZERO)
c     call GetEdc(0.0)
      return
      END
cn
c     ------------------------------------------------------------------
c
      SUBROUTINE jnorm(ip)
#include "Implic.inc"
#include "MKSetc.inc"
#include "PIetc.inc"
#include "params.inc"
#include "Jrf.inc"
#include "ProfBody.inc"
#include "FeBins.inc"
      INTEGER ip, iv
c     set up normalization, tabulate u lookup values
      gmrun = NeAry(ip) * LnlAry(ip) * ECOULB**4 / ELECMS**2 * CLIGHT *
     ^        4.*PI * 1.0e-14
      if(EdcAry(ip) .ne. 0.)then
         vnorm = sqrt(abs(NeAry(ip) / EdcAry(ip)))   *
     ^           sqrt(ECOULB**3 / ELECMS * CLIGHT **2 * LnlAry(ip) *
     ^           4. * PI ) * 1.0e-9
         if( EdcAry(ip) .gt. 0.)then
            muplus  = +1.
            muminus = -1.
         else
            muplus  = -1.
            muminus = +1.
         endif
      else
         vnorm = vnmax
         muplus = 1.
         muminus = -1.
      endif
      nuRuna = gmrun / (vnorm * vnorm * vnorm)
      do 10 iv = 1, nv
        ugr(iv) = Vpar(iv) / vnorm * muminus
 10   continue
c
c
          ivrun = 0
      if (muminus .eq. -1) then
        do 20 iv = (nv+1)/2, nv-1
          if ( ugr(iv)  .le. -1. .and. ugr(iv-1)  .gt. -1.) then
            ivrun = iv
            goto 40
          endif
 20     continue
      else
        do 30 iv = 2,(nv+1)/2
          if ( ugr(iv)  .le. -1. .and. ugr(iv-1)  .gt. -1.) then
            ivrun = iv
            goto 40
          endif
 30     continue
      endif
c
 40   continue
      return
      END
c      
c     ------------------------------------------------------------------      
c
      SUBROUTINE mkj(ip, jd, iGotRuna, iFillJray)
#include "Implic.inc"
#include "MKSetc.inc"
#include "params.inc"
#include "Jrf.inc"
#include "ProfBody.inc"
#include "FeBins.inc"
#include "DqlBins.inc"
#include "WkAry.inc"
#include "power.inc"
      INTEGER ip, iv, iGotRuna, iWhichWay, iSMOi, iFillJray
      REAL    jd, jdtemp, constfac
      REAL    FeCutFac, FeCutOff
      DATA    FeCutFac / 1.0e-5 /
      REAL    dWsdu, dWsduou
c     compute jrf driven, jd, at flux surface ip
      jd = 0.
      constfac =   ECOULB * CLIGHT * 1.0e-5/ nuRuna 
      iGotRuna = 0
      iSMOi = mod(iSMO,2) + 1
      FeCutOff = FeCutFac*fe(IvZero,ip,iITR)
c
c     .
c     .                                 first negative velocities 
c     .
      do 10 iv = 1, IvZero - 1
c     .                                 Ignore jd where f_e is small
        if ( fe(iv,ip,iITR) .ge. FeCutOff ) then
c     .                                 Muplus, because mu is plus for
c     .                                 negative velocity if the Edc is >0
c     .                                 See above for reversal if E<0
          call WsloPrm(ugr(iv), muplus , ZbrAry(ip), 
     ^                 dWsduou, iWhichWay)
          dWsdu = dWsduou  * ugr(iv)
c     .                                 Note that dWsdu*ugr is always positive
          if (iWhichWay .ne. 0 ) iGotRuna = iGotRuna + 1
c     .                                 For negative velocity the current
c     .                                 driven is negative because df/dv >0
c
          jdtemp      = - Dql(iv, ip, iSMO) * dfdv(iv,ip,iSMOi) * 
     ^                                         dvplus(iv) *  dWsdu *
     ^                    constfac
          jd = jd + jdtemp
          if(iFillJray .eq. 1) Jray(iv,ip) = jdtemp
        endif
 10   continue
c     .
c     .                                 then positive velocities
c     .
      do 20 iv = IvZero + 1, nv - 1
c     .                                 Ignore jd where f_e is small
c     .                                 Muminus, because mu is neg for 
c     .                                 positive veloctiy if the Edc is >0
c     .                                 See above for reversal if E<0
        if ( fe(iv,ip,iITR) .ge. FeCutOff ) then
          call WsloPrm(ugr(iv), muminus , ZbrAry(ip), 
     ^                 dWsduou, iWhichWay)
          dWsdu = dWsduou  * ugr(iv)
c     .                                 Note that dWsdu*ugr is always positive
          if (iWhichWay .ne. 0 ) iGotRuna = iGotRuna + 1
c     .                                 For positive velocity the current 
c     .                                 driven is positive because df/dv<0
c
          jdtemp      = - Dql(iv, ip, iSMO) * dfdv(iv,ip,iSMOi) * 
     ^                                         dvplus(iv) *  dWsdu *
     ^                    constfac
          jd = jd + jdtemp
          if(iFillJray .eq. 1) Jray(iv,ip) = jdtemp
        endif
 20   continue
c      use of 'constfac' removes the need for this Oct 94
c      jd =  jd / nuRuna * ECOULB * CLIGHT * 1.0e-5

      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE GetEdc (DifAmt)
#include "Implic.inc"
#include "params.inc"
#include "ProfBody.inc"
#include "RayBins.inc"
#include "TSCgrap.inc"
#include "PIetc.inc"
      INTEGER idxPsi
      REAL    DifAmt, psi, Edc
      REAL    MinEdc
      DATA    MinEdc    / 0.0001 /
c     DifAmt is intended to be 0.0 when the E_dc is desired as given
c     and intended to be something like 0.0001 when we are trying to form
c     the derivative   d ln J / d ln E
c
c
      do 10 idxPsi = 1, npsi
        psi = PsiAry(idxPsi)
        call linr1d(NpsiJ, PsiVec, EdcVec,
     ^       psi, Edc)
        Edc = Edc + DifAmt
        if (abs(Edc) .le. MinEdc) then
          if (Edc .ge. 0. ) then 
            Edc = +MinEdc
          else
            Edc = -MinEdc
          endif
        endif
        EdcAry(idxPsi) =  Edc
 10   continue
c
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE ddtNrnJrn (ip,nDot, jDot, vRunAwayIndex)
#include "Implic.inc"
#include "MKSetc.inc"
#include "params.inc"
#include "FeBins.inc"
#include "DqlBins.inc"
#include "Jrf.inc"
c     Added Aug 93 to help quantify the runaway situation for LSC report
c     PPPL 2929
      INTEGER ip,iSMOi
      REAL    nDot, jDot, vRunAwayIndex
c
      iSMOi = mod(iSMO,2) + 1

        nDot= 0.00
        JDot= 0.00
        vRunAwayIndex= 0.00
c     if (ivrun .gt. 1 .or.  ivrun .lt. nv ) then   BLUNDER repaired AUG 95
      if (ivrun .gt. 1 .and. ivrun .lt. nv ) then
        nDot =             Dql(ivrun, ip, iSMO) * dfdv(ivrun,ip,iSMOi) 
        jDot = vpar(ivrun)*Dql(ivrun, ip, iSMO) * dfdv(ivrun,ip,iSMOi) 
c
        nDot = abs ( nDot )
        jDot = abs ( JDot )* ECOULB * CLIGHT * 1.0e-5
        vRunAwayIndex = float(ivrun)
      endif
c
      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE JdepFromTSC(curtsc,djdets2,npsiTake)
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "PIetc.inc"
#include "ProfBody.inc"
#include "Jrf.inc"
#include "TSCgrap.inc"
c
      INTEGER l, ip, ips, iGotRuna, npsiTake, PassNumber, iFillJray
      REAL    curtsc(npsiTake), djdets2(npsiTake), curtscI(PPSI)
      REAL    xlookup, yreturn
      REAL    PowFac        , CurFac   
      DATA    PowFac        , CurFac        /
     ^            1.e-6     ,     1.e-4     /
c             m^3 per cm^3  , m^2 per cm^2 
      DATA iFillJray / 0 /
      REAL    ZERO
      DATA    ZERO/
     ^         0.0/
c
c
      Passnumber = 1
c
 1    continue
c
      if (PassNumber .eq. 1) then
        call GetEdc(ZERO)
c       call GetEdc(0.0)
      else
        call GetEdc(dEdcAmnt)
      endif
c                                       Fill array EdcAry
c     .                                 with 0.0 difference from the EdcVec
c     .                                 transferred from TSC; on second pass
c     .                                 fill with the dEdcAmnt
      do 10 ip = 1, npsi
        call jnorm(ip)
c     .                                 compute jrf
        call mkj(ip,js(ip), iGotRuna, iFillJray)

 10   continue
c
      IrIntgrl(1) = js (1) * dVol(1) / (TWOPI * xmag )
      do 17 ips = 2, npsi
         IrIntgrl(ips) = IrIntgrl(ips-1) + js(ips)*dVol(ips) /
     ^                                    (TWOPI * xmag )
c     Divide by 2 pi R to make an area element !
 17   continue

      do 20 l = 1, NpsiJ - 1
         xlookup =  MidVec(l)
c
c     interpolate for current integral
         call linr1d(Npsi, MidAry, IrIntgrl, 
     ^               xlookup, yreturn)
         curtscI (l)=  yreturn
 20   continue

      curtscI (NpsiJ) = IrIntgrl(Npsi)
      curtscI (NpsiJ-1) = IrIntgrl(Npsi)

      l = 1
      if(PassNumber .eq. 1)
     ^curtsc (l)= CurFac * (curtscI (l)             )/
     ^                    ( dVlVec(l) / (TWOPI * xmag) )
      if(PassNumber .eq. 2)
     ^djdets2(l)= CurFac * (curtscI (l)             )/
     ^                    ( dVlVec(l) / (TWOPI * xmag) )
      do 30 l = 2, NpsiJ - 1
        if(PassNumber .eq. 1)
     ^  curtsc (l)= CurFac * (curtscI (l)-curtscI (l-1))/
     ^                      ( dVlVec(l) / (TWOPI * xmag) )
c
c     .                                 djdets2 contains temporarily
c     .                                 the current at the incremented E
        if(PassNumber .eq. 2)
     ^  djdets2(l)= CurFac * (curtscI (l)-curtscI (l-1))/
     ^                      ( dVlVec(l) / (TWOPI * xmag) )

c       I have to mult by 2 pi R to make an area!

 30   continue
      
      if(PassNumber .eq. 1) then
        PassNumber = 2
        goto 1
      endif
 
c
c     !! Are NpsiJ and npsiTake right??
c
      do 40 l=npsiTake,2,-1
        curtsc (l)=curtsc (l-1)
        djdets2(l)=djdets2(l-1)
 40   continue
        l = 1
        curtsc (l)= 0.00
        djdets2(l)=0.00

      do 50 l=2,npsiTake
        djdets2(l) = (djdets2(l) - curtsc (l))/ dEdcAmnt   
 50   continue

      return
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE SmoJandP(Radius)
#include "Implic.inc"
#include "MKSetc.inc"
#include "PIetc.inc"
#include "params.inc"
#include "RayBins.inc"
#include "ProfBody.inc"
#include "Jrf.inc"
#include "power.inc"
      INTEGER ip, idxFor0
      REAL    Radius
      REAL    NuSlow(NPSIDIM), Jdriven(NPSIDIM), Jdiffus(NPSIDIM),
     ^        Awk(NPSIDIM),    Bwk(NPSIDIM),     Cwk(NPSIDIM), 
     ^        Jwk(NPSIDIM),    Xwk(NPSIDIM),     NparCube
      REAL    PrfNorm,         PrfOrig(NPSIDIM), PrfSmoo(NPSIDIM)
      EQUIVALENCE (PrfOrig(1),Jdriven(1))
      EQUIVALENCE (PrfSmoo(1),Jdiffus(1))
      PARAMETER (NparCube = 8.0)
c
c     Do nothing if there is no diffusion; or no sensible radius
      if (DiffuJrf .le. 0.00 .or. Radius .le. 0.00) return

c     Form the 'slowing down frequency'
c     \nu_slow = \ln \lambda n_e e^4 /(4 \pi \epsilon_0^2 m_e^2 c^3) 
c                \times  n_\parallel^3
c
c     The assumed boudary conditions in SmoothJrf are that there is
c     a guard point on the low(central) side of the passed array:
c         > zero slope (in r-space) on inner side
c         > zero value on the outer side at idxFor0 
c     However, idxFor0 must not be more than npsi+1
c
      do ip=1,npsi
        NuSlow(ip) =  NeAry(ip) * LnlAry(ip) * 
     ^               ECOULB**4 / ELECMS**2 * CLIGHT *
     ^               4.*PI * 1.0e-14 * NparCube
      enddo
c
c     Smooth the current computed with the given field:
      do ip=1,npsi
         Jdriven(ip) = js(ip)
         if(Jdriven(ip) .ne. 0.00) idxFor0=ip
      enddo
         if(idxFor0 .lt. npsi-1) idxFor0 = (npsi + idxFor0)/2
      call SmoothJrf      (Radius, DiffuJrf, npsi, idxFor0,
     ^                     NuSlow, Jdriven, Jdiffus,
     ^                     Awk, Bwk, Cwk, Jwk, Xwk,
     ^                    'PolFlux_Like', 'Zero2ndDeriv')
      do ip=1,npsi
         js(ip) = Jdiffus(ip)
      enddo
c
c     Smooth the current computed with the given field plus delta-field
      do ip=1,npsi
         Jdriven(ip) = jsp(ip)
      enddo
c
      call SmoothJrf      (Radius, DiffuJrf, npsi, idxFor0,
     ^                     NuSlow, Jdriven, Jdiffus,
     ^                     Awk, Bwk, Cwk, Jwk, Xwk,
     ^                    'PolFlux_Like', 'Zero2ndDeriv')

      do ip=1,npsi
         jsp(ip) = Jdiffus(ip)
      enddo
c
      if(PrfSpred .le. 0.00 .or. PrfSpred .gt. 1.00) return
c     Smooth Power according to 
c         Praytot(psi) = Prf-total n(psi) J-diffused(psi) dV(psi) / 
c                        [ \Sigma  n(psi) J-diffused(psi) dV(psi) ] *
c                                                 PrfSpred     +
c                  Prf-ray-undiffused(psi)* (1. - PrfSpred) 
c
c     Calculate normalization factor
         PrfNorm = 0.00
      do ip=1,npsi
         PrfNorm     = abs(js(ip))*NeAry(ip)*dVol(ip) + PrfNorm
      enddo
         PrfNorm     = PraySum / PrfNorm
c
c     Calculate raw smoothed power
      do ip=1,npsi
         PrfOrig(ip) = PRaytot(ip)
         PrfSmoo(ip) = abs(js(ip))*NeAry(ip)*dVol(ip) * PrfNorm 
      enddo
c
c     Fold raw smooth power with unsmoothed power
      do ip=1,npsi
         PrfSmoo(ip) = PrfSpred*PrfSmoo(ip) + (1.-PrfSpred)*PrfOrig(ip)
         PrayTot(ip) = PrfSmoo(ip)
      enddo

      return
      END
c
c     -----------------------------------------------------------------|
c
c     SUBROUTINE SmoothJrf(Radius, DiffCoef, NumJs, ....
c
c     Routine to Smooth Jrf
c     Copyright 1994 by
c     D. W. Ignat and S. C. Jardin
c     Plasma Physics Laboratory
c     Box 451
c     Princeton, New Jersey 08543
c
c     Smooth RF-driven current with a diffusion-like equation.
c     The idea is that the actual RF-driven current is modified from
c     the computed RF-driven current by slowing-down, characterized by
c     an inverse-time \nu_slow, and a cross-field diffusion, 
c     characterized by DiffCoef.
c
c     Jdriven is given on points 1,2,...NumJs; regularly spaced
c     in poloidal flux. We add guard points at 0 and NumJs + 1.
c     We assume that poloidal flux is like radius squared, so that
c     the diffusion-like equation in radius
c
c     dJrf/dt = \nu_{slow} (Jdriven-Jrf) + 1/r d/dr( r DiffCoef dJrf/dr)
c
c     becomes
c
c     dJrf/dt = \nu_{slow} (Jdriven-Jrf) + d/dx(4 x DiffCoef dJrf/dx)/Radius^2
c
c     where  x  is normalized poloidal flux ranging from 0 to 1.
c
c     More correct use of generalised coordinates would follow this:
c         df/dt = 1/Jac  d/dp[ Jac (grad p)**2 D df/dp ]
c         where Jac is the Jacobian, or volume element factor.
c         Jac == (1/grad p) (\int^p dp/grad p)
c     In the case of p ~ r^2, grad p = 2 sqrt(p) and
c     \int^p dp/grad p== sqrt(p) so the J is 1/2, and cancels out.
c
c     We solve the equation for the steady state, from a difference
c     equation
c     
c     Radius^2  *  \nu_slow
c     ----------------------  *  (Jrf - Jdriven) ==
c     4 DiffCoef (NumJs+1)^2
c
c    (xp+x)/2 * (Jrfp-Jrf) - (x+xm)/2 * (Jrf-Jrfm)
c
c     where xp is x-plus xm is x-minus etc and \delta x = 1/(NumJs+1)
c
c     The boundary condtions at index 0,1,2 are :
c        (1) that Jrf is constant (Jdiff_0 = Jdiff_1)              <or>
c        (2) that Jrf slope is constant (Jdiff_0 = 2 Jdiff_1 - Jdiff_2)
c
c     and at index idxFor0 that Jrf is zero.  Normally, one expects that
c     idxFor0 is NumJs+1, but maybe the current should not be zero at the edge-
c     it should be zero at idxFor0.
c
c     Boundary condition (1) goes naturally with radius-like coordinates;
c     Boundary condition (2) goes naturally with flux-like coordinates.
c
c     \nu_slow = \ln \lambda n_e e^4 /(4 \pi \epsilon_0^2 m_e^2 c^3) 
c                \times  n_\parallel^3
c     where n_e is position dependent...but does not have to be.
c     Obviously, any fudge factor can be thrown in on the \nu_slow or on
c     the DiffCoef owing to the heuristic derivation of this treatment.
c     The extention to spatially varying DiffCoef is straightforward.
c
c     A modification for an input Jrf based on a radius-like grid 
c     is very simple:
c
c     Radius^2  *  \nu_slow
c     ----------------------  *  r * (Jrf - Jdriven) ==
c     1 DiffCoef (NumJs+1)^2
c
c    (rp+r)/2 * (Jrfp-Jrf) - (r+rm)/2 * (Jrf-Jrfm)
c
c     where rp is r-plus rm is r-minus etc and \delta r = 1/(NumJs+1)
c
c     This spirit of this approach is similar to that of
c     V. Fuchs, I. P. Shkarofsky, R. A. Cairns, and P. T. Bonoli,
c     ``Simulations of lower hybrid current drive and ohmic transformer
c     recharge,'' Nuclear Fusion {\bf 29} 1479 1989.  
c     It appears that the practical difference is that 
c     in the Fuchs work a loss-rate at the edge is specified, 
c     rather than the DiffCoef, and then the DiffCoef
c     is found by a shooting method. 
c
c     In contrast, the present routine specifies the DiffCoef and finds
c     the modified (reduced) current.
c     (and the current loss by implication)
c     
c     The following is a heuristic derivation of the formula, 
c     loosely based on the Fuchs paper:                  (rectangular coords!)
c
c    df/dt = d/dv ( Dq df/dv )  + d/dv(Dc df/dv + \nu v f) + d/dr(D df/dr)
c            RF (q-l) souce term  Collisional terms        Spatial  Diffusion
c
c   multiply by e v and integrate over v, 
c   integrating by parts in first 3 terms on RHS
c
c    dJ/dt = \int e(-Dq df/dv) dv + \int e(-Dc df/dv) dv - \int \nu e v f dv
c            RF q-l source term    Collisional diffusion  Dynamical friction
c
c           +                                                d/dr(D dJ/dr)
c                                                           Spatial Diffusion 
c
c   In the dynamical friction term, pull \nu out of the integral 
c   making it \nu_eff \cdot {fudge-factor}, but call it \nu still.
c   Then you have - \nu J for that term
c
c   Tell yourself that if RF is there, the q-l source overwhelms the
c   collisional velocity diffusion, which we now ignore.  Then
c 
c    dJ/dt = \int e(-Dq df/dv) dv  -\nu J + d/dr( D dJ/dr )
c
c   Tell yourself that the rf souce term can be written as
c   \nu' times the RF current found in the normal LSC calculation J_o;
c   and then tell yourself that we might as well treat \nu' == \nu
c
c   Then
c 
c     dJ/dt = \nu (J_o - J) +  d/dr ( D dJ/dr ) 
c
c   This has some desirable properties, like if
c   D is small then the J moves to J_o on the \nu time scale 
c   and if D is large then J and J_o can be quite different.
c   Also if \nu is space-dependent and D not then the J will 
c   tend to move out (as Giruzzi finds) because there are
c   fewer collisions there.  
c
c   It does not do anything like move the fast particles around
c   and change the damping because of moved fast particles.
c
c   The Edc treatment based on Karney Fisch is a confused 
c   thing after this.
c
c
      SUBROUTINE SmoothJrf(Radius, DiffCoef, NumJs, idxFor0,
     ^                     NuSlow, Jdriven, Jdiffus,
     ^                     Awk, Bwk, Cwk, Jwk, Xwk,
     ^                     IndeptVar, BoundCond)
#include "Implic.inc"
      INTEGER NumJs, idxFor0, idxFor0m1
      REAL    Radius, DiffCoef
      REAL    NuSlow(NumJs), Jdriven(NumJs), Jdiffus(NumJs)
      REAL    Awk(NumJs), Bwk(NumJs), Cwk(NumJs), Jwk(NumJs)
      REAL    Xwk(NumJs), xwk0
      REAL    TimeDum, Jp1
      INTEGER i, ierror
      CHARACTER*(*) IndeptVar, BoundCond
      REAL    BC1, BC2
c
      Jp1 = float(NumJs+1)

      if (idxFor0 .lt. NumJs) then
         idxFor0m1 = idxFor0 - 1
      else
         idxFor0m1 = NumJs
      endif
c
c     Default Radial Independent Variable Type is:  PolFlux_Like
c     This is Area_Like.  
c
      if (IndeptVar .eq. 'RadDist_Like') then
         TimeDum = Radius**2/(1.*DiffCoef) / Jp1**2
      else if (IndeptVar .eq. 'PolFlux_Like')then
         TimeDum = Radius**2/(4.*DiffCoef) / Jp1**2
      else
         TimeDum = Radius**2/(4.*DiffCoef) / Jp1**2
      endif
c
c     Zero slope boundary condition at i=0;i=1 or
c     Zero second deriv boundary condition at i=0;i=1;i=2
      if(BoundCond .eq. 'Zero1stDeriv') then
         BC1 = 1.0
         BC2 = 0.0
      else if(BoundCond .eq. 'Zero2ndDeriv') then
         BC1 = 2.0
         BC2 =-1.0
      else        
         BC1 = 1.0
         BC2 = 0.0
      endif
c
c     Xwk is filled with the average value of x(i) and x(i+1);
c     a more important purpose is workspace for the matrix inverter.
c     Xwk does not have to be filled above index idxFor0m1, but we
c     fill it anyway to emphasize that xwk goes with the geometry of
c     the problem, not with where we think the current must go to zero.
c
      do i=1,NumJs
         xwk(i) = (float(i)+0.5)/ Jp1
      enddo
         xwk0 = 0.5/Jp1
c
      Awk(1)     = 0.0
      Bwk(1)     = TimeDum*NuSlow(1) 
      if(IndeptVar .eq. 'RadDist_Like') Bwk(1) = Bwk(1)*1./Jp1
      Bwk(1)     = Bwk(1) + xwk0*(1.-BC1) + xwk(1)
      Cwk(1)     = - (xwk(1) + BC2*xwk0 )
c
c     Awk(1) and Cwk(NumJs) are never used;  setting to zero is cosmetic
c      
      do i=2,idxFor0m1
         Awk(i) = - xwk(i-1)
         Bwk(i) = TimeDum*NuSlow(i)
         if(IndeptVar .eq. 'RadDist_Like') Bwk(i) = Bwk(i)*float(i)/Jp1
         Bwk(i) = Bwk(i) + xwk(i-1) + xwk(i)
         Cwk(i) = - xwk(i)
      enddo
c
c     Zero value boundary condition at i=idxFor0
      Cwk(idxFor0m1) = 0.0
c
c     Awk(1) and Cwk(idxFor0-1) are never used;  setting to zero is cosmetic
c      
      do i=1,idxFor0m1
         Jwk(i) = TimeDum*NuSlow(i)*Jdriven(i)
         if(IndeptVar .eq. 'RadDist_Like') Jwk(i) = Jwk(i)*float(i)/Jp1
      enddo
c
c
c     Find the 'diffused' current; 
c     Note that we are done with Xwk, and now pass it to tridiaNR for
c     it to use as workspace.  
c
      call tridiaNR(Awk,Bwk,Cwk,Jwk,Jdiffus,idxFor0m1,
     ^                                        Xwk,ierror)
c     Fill remaining Jdiffused locations with zeros, if necessary.

      if (idxFor0 .le. NumJs) then
         do i=idxFor0, NumJs
            Jdiffus(i) = 0.00
         enddo
      endif

      if (ierror .ne. 0) then
         do i=1,NumJs
            Jdiffus(i) = Jdriven(i)
         enddo
      endif
      return 
      END 
c
c     -----------------------------------------------------------------|
c
      SUBROUTINE tridiaNR (a,b,c, r,u,n,
     ^                              gam,ierror)
c     References: 
c     Numerical Recipies in Fortran by William H. Press, 
c     et al, Ch 2; p 40.
c     
c     Solves for a vector  u  of length  n  the tridiagonal linear set:
c
c     b1   c1   0    0    0    0    0        u1          r1
c     a2   b2   c2   0    0    0    0        u2          r2
c     0    a3   b3   c3   0    0    0        u3          r3
c     0    0    a4   b4   c4   0    0        u4      =   r4
c     ..   ..   ..   ..   ..   ..   ..       ..          ..
c     ..   ..   ..   ..   aN-1 bN-1 cN-1     uN-1        rN-1
c     .              ..   0    aN   bN       uN          rN
c
c     a  b  c  r  are input vectors and are not modified.
c     
#include "Implic.inc"
      INTEGER n, j, ierror
      REAL    a(n), b(n), c(n), r(n), u(n)
      REAL    bet
c     PARAMETER (NMAX = 200)  ! as given in the book
c     REAL    gam(NMAX)       ! as given in the book
      REAL    gam(n)
c
c     Trap error on ill-posed problem:
c     if (b(1) .eq. 0.) stop ' b1 is zero in tridiag' ! as given in the book
      ierror = 0
      if (b(1) .eq. 0.) then
         ierror=1
         goto 1313
      endif
c
c     Normal beginning point:
      bet = b(1)
      u(1)= r(1)/bet
c
      do 11 j=2,n
        gam(j) = c(j-1)/bet
        bet    = b(j) - a(j)*gam(j)
c                if (bet .eq. 0.) stop ' tridiag fails' ! as given in the book
                 if (bet .eq. 0.) then
                    ierror=2
                    goto 1313
                 endif
        u(j)   = ( r(j) - a(j)*u(j-1))/bet
 11   continue
c
      do 12 j=n-1,1,-1
        u(j) = u(j)-gam(j+1)*u(j+1)
 12   continue
c
      return
c
c     Error condition...
 1313 continue
      return
c
      END
c
c     ------------------------------------------------------------------
c
      SUBROUTINE JrfDiagn
#include "Implic.inc"
#include "tscunits.inc"
#include "params.inc"
#include "Doflags.inc"
#include "PlPr.inc"
#include "FeBins.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "ProfBody.inc"
#include "WkAry.inc"
#include "Jrf.inc"
      INTEGER ivlocal, iplocal
      INTEGER ipstep, ThisPlot, NumPlts, iCross0
      CHARACTER*1 curve, dots, altdots, cros, bars
      CHARACTER*10 chip
      CHARACTER*24 MyString
      CHARACTER*30 TSCstring
      REAL    nparlocal

      INTEGER NumJofN, inlocal, iymjr, iymnr, nsmo
      REAL    NpLocMin, NpLocMax
      PARAMETER (NumJofN=101, NpLocMin=-10., NpLocMax=10.)
      REAL    JofNpar(NumJofN), NparVec(NumJofN)
      REAL    JofNmin, JofNmax, NparLog(20)
      PARAMETER (nsmo=5)
      REAL    smofn(nsmo)
      REAL  
     ^        ZERO, ONE, ONEPT2
      DATA    ZERO, ONE, ONEPT2/
     ^         0.0, 1.0,    1.2/
      DATA curve, dots,altdots, cros, bars,  NumPlts  /
     ^       ' ',  '.',    ',',  'x',  '|',       12  /
      DATA smofn(1), smofn(2), smofn(3), smofn(4), smofn(5) /
     ^      1.     ,  2.     ,  3.     ,  2.     ,  1.      /
      ipstep = (npsi - 2)/NumPlts
      ivlocal = 1

      if(PlFlg(RFDPL) .ge. TRUE)then
            ivlocal = 1
            ThisPlot = 1
            do 20 iplocal = ipstep, ipstep*NumPlts, ipstep
c     .                                 if chip starts with a 'l' or 'L'
c     .                                 then the logarithm is plotted
               write(chip,'(''Jray('',i2,'')'')') iplocal
c
c     .                                 call the curve line first... this
c     .                                 sets the scale of the graph
               call Dql6Norm(Vpar(ivlocal),Jray(ivlocal,iplocal),nv,
     ^                           chip,bars, ThisPlot, NumPlts)
c
               ThisPlot = ThisPlot + 1 
c
 20         continue
c
            call BrodCast(nv, wkv,    0.)
            do ivlocal = 1,nv
               do iplocal = 1,npsi
                  wkv(ivlocal)=wkv(ivlocal) + Jray(ivlocal,iplocal)
               enddo
            enddo
c           EZnorm ( fin , fout , fmin , fmax , n , iCross0) 
c            iCross0=1+1=2 --> crosses 0; iCross0=1+0=1 --> not cross 0
            call EZnorm ( wkv, wkv , wkv(nv+1),wkv(nv+2), nv, iCross0 )
c bar graph of Pray(iv)
            call EZsets (    600,    1000, 125, 375,
     ^                       -ONE,    ONE,-ONEPT2, ONEPT2, 1)
            call GNsets (    500,    1000,   0, 380,
     ^                       -ONE,    ONE,-ONEPT2, ONEPT2, 1)
            write (MyString,'( ''Jray(v/c)/'', 1pe8.1,''$'')') wkv(nv+2)
            call EZwrit(600, 400, MyString , 0, 0 )
            call GNtitl(          MyString        )
            call EZaxes (2,5,1,6)
            call EZbars(vpar,wkv,nv,'y')
            call GNbars(vpar,wkv,nv,'y')
c
c continuous graph of Jray(iv)
            call EZsets (    600,    1000, 475, 725,
     ^                       -ONE,    ONE,-ONEPT2, ONEPT2, 1)
            call GNsets (    500,    1000, 380, 760,
     ^                       -ONE,    ONE,-ONEPT2, ONEPT2, 1)
            write (MyString,'( ''Jray(v/c) curve'',''$'')') 
            call EZwrit(600, 750, MyString , 0, 0 )
            call GNtitl(          MyString        )
            call EZaxes (2,5,1,6)
            call EZcurv(vpar,wkv,nv)
            call GNcurv(vpar,wkv,nv)
c bar graph of Jray(npar)
            call BrodCast(NumJofN, JofNpar, 0.0)
            call ugrid(NparVec,NumJofN, NpLocMin, NpLocMax)
            do ivlocal = 1,ivZero-1
               nparlocal= amax1(1./vpar(ivlocal), NpLocMin)
               inlocal = int((nparlocal-NpLocMin)
     ^                         / 20.*float(NumJofN-1)) + 1
               JofNpar(inlocal) = JofNpar(inlocal) + wkv(ivlocal)
            enddo
            do ivlocal = ivZero+1,nv
               nparlocal= amin1(1./vpar(ivlocal), NpLocMax)
               inlocal = int((nparlocal-NpLocMin)
     ^                         / 20.*float(NumJofN-1)) + 1
               JofNpar(inlocal) = JofNpar(inlocal) + wkv(ivlocal)
c               call EZbars(nparlocal,wkv(ivlocal),1,'y')
            enddo
            call vecnorm(NumJofN, JofNpar)
            call vecMnMx(JofNpar,NumJofN, JofNmin, JofNmax)
            call EZrnd2  (JofNmax, JofNmax, iymjr, iymnr)
            call EZsets (  100,     500, 125, 375,   
     ^                NpLocMin,NpLocMax,-JofNmax, JofNmax, 1)
            call GNsets (    0,     500,   0, 380,   
     ^                NpLocMin,NpLocMax,-JofNmax, JofNmax, 1)
            write (MyString,'(''Jray(npar)'',''$'')')
            call EZwrit(100, 400, MyString , 0, 0 )
            call GNtitl(          MyString        )
            call EZaxes (2,5,iymjr,iymnr)
            call EZbars(NparVec,JofNpar,NumJofN,'y')
            call GNbars(NparVec,JofNpar,NumJofN,'y')
c continuous graph of Pray(npar)
            call vecnorm(nsmo,smofn)
            call smooth(JofNpar,NumJofN,NumJofN,1,nsmo,smofn)
            call EZsets (  100,     500, 475, 725,   
     ^                NpLocMin,NpLocMax,-JofNmax, JofNmax, 1)
            call GNsets (    0,     500, 380, 760,   
     ^                NpLocMin,NpLocMax,-JofNmax, JofNmax, 1)
            write (MyString,'(''Jray(npar) curve'',''$'')')
            call EZwrit(100, 750, MyString , 0, 0 )
            call GNtitl(          MyString        )
            call EZaxes (2,5,iymjr,iymnr)
            call EZcurv(NparVec,JofNpar,NumJofN)
            call GNcurv(NparVec,JofNpar,NumJofN)
            write(TSCstring,'( '' Jray(iv) vs v/c '')') 
c close frame
            call MkGrfLst( TSCstring )
            call EZfini(0,0)
            call GNfini
         endif
      return
      END
c     .                                                                |
c     .                                                                |
c     jrf.F ends   -----------------------------------------------------
