c     ql.f(or)  begins                      ---------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE Smooth(rmat, n1, n1dim, n2, nsmoo, smvec)
#include "Implic.inc"
#include "params.inc"
#include "WkAry.inc"
      INTEGER ipsi, nsm2, n1, n2, nsmoo, n1dim
      REAL rmat(n1dim, n2), smvec(n1dim)
c     smooth quasilinear diffusion coefficient 
c     VecDmp in matr.F puts the Dql values for each v into wkv.
c
c     The calling logic is tricky in that it depends on storage order in f77.
c     convolve takes wkv, outputs Dql.  If qlsm is a delta fn, no change.
c     qlsm is integer vector gaussian of width nsmw, normalized to add to 1.

      nsm2 = (nsmoo - 1) / 2
      do 10 ipsi=1, n2
         call VecDmp(rmat(1,ipsi), wkv, n1, 1)
         call convolve(n1, nsm2, smvec, rmat(1, ipsi), wkv)
 10   continue
      
      return
      END
c     ----------------------------------------------------------------- 
      SUBROUTINE DqlGen
c     deposit wave energy into dql matrix
#include "Implic.inc"
#include "params.inc"
#include "DqlBins.inc"
#include "FeBins.inc"
#include "RayBins.inc"
      INTEGER iv, ip, iNotSmoo, iYesSmoo
      INTEGER iry, izn
      DATA iNotSmoo, iYesSmoo / 1 , 2 /
c     deposit energy density on ray iray and zone izone
c     into appropriate
c     velocity bin.
c     See eq 22 and 28 of Valeo/Eder.
c     D_{ql} = \pi/2 (e/m)^2 Sum_j <E_z_j^2> \delta(\omega - k_par v_par)
c     where the j represents all rays and intersections with the flux surface
c     in question (index supressed here) and the <> mean flux surface avg.
c     The factor 2 is appropriate for E meaning an amplitude; it makes the
c     E^2 into an rms quantity.
c     The delta function connects the k-par dependence of E with the v
c     dependence of D.  
c     \delta(w) = (2\pi h)^{-.5} exp(-(w/h)^2/2.) where h is a variable
c     width.  By writing in terms of velocity index and nsmoo
c     
c     D(v_i) = \pi/2 (e/m)^2 Sum_j E_j^2 (v_par/(\omega \Delta v_par) *
c         (2\pi nsmoo)^{-.5} exp (- (i-j)^2/(2 nsmoo^2)) 
c
c     .                                 Clear the unsmoothed part of Dql
      call DqlClear
c     .                                 Fill up the unsmoothed part of Dql
      do 20 iry  = 1, nrays
         
         do 10 izn   = 1, nzones-1
            iv = ivind(izn  , iry )
c                                       If  ivind=0, the ray was stopped before
c                                       reaching this izone (izn).
c                                       If Power =0, no contribution to Dql
c                                       No calculation is appropriate.
            if (             iv .eq. 0   .or. 
     ^          Power(izn,iry)  .eq. 0.00   ) go to 11
            ip = izind(izn  , iry )
c
c     We take the peak power as equal to the average power.   
c
c           if ( iFudgDmp(iry) .eq. izn) then
c
c              Dql(iv, ip, iNotSmoo) = Dql(iv, ip, iNotSmoo) + 
c     ^            Power(izn  , iry ) * rFudgDmp(iry)
c     ^           * Ezsq(izn  , iry ) * abs(vpar(iv)) / dvsym(iv)
c            else
c              Dql(iv, ip, iNotSmoo) = Dql(iv, ip, iNotSmoo) + 
c     ^            Power(izn  , iry )
c     ^           * Ezsq(izn  , iry ) * abs(vpar(iv)) / dvsym(iv)
c            endif

              Dql(iv, ip, iNotSmoo) = Dql(iv, ip, iNotSmoo) + 
     ^            Power(izn  , iry ) * rFudgDmp(izn,iry)
     ^           * Ezsq(izn  , iry ) * abs(vpar(iv)) / dvsym(iv)
c           
 10      continue
 11   continue   
 20   continue
c
c     .                                 Multiply by normalization
      call svmult(NVELDIM * NPSIDIM, Dql, Dqlnorm, Dql)
c
c     .                                 Copy unsmoothed into space for smoothed
      do 30 iv=1,NVELDIM
        do 25 ip=1,NPSIDIM
          Dql(iv,ip,iYesSmoo) = Dql(iv,ip,iNotSmoo)
 25     continue
 30   continue
c
c     .                                 Smooth the new copy
      call Smooth(Dql(1,1,iYesSmoo), 
     ^            nv, NVELDIM, npsi, nsmoo, qlsm)

      return
      END
c     ----------------------------------------------------------------- 
      SUBROUTINE DqlClear
#include "Implic.inc"
#include "params.inc"
#include "DqlBins.inc"
      call BrodCast(NVELDIM * NPSIDIM, Dql, 0.)
      return
      END
c     -----------------------------------------------------------------
      INTEGER FUNCTION ivtabl(np)
#include "Implic.inc"
#include "params.inc"
#include "FeBins.inc"
      INTEGER iv
      REAL
     ^     np, vv
      vv = 1. / np
      iv = 2
 5    continue
      if( (iv .le. nv) .and. (vpar(iv) .lt. vv) ) then
         iv = iv + 1
         go to 5
      endif
c
c                                       v grid symmetery question:
c                                       use vpar nearby of smaller energy
      if( iv .gt. ivZero) then
        ivtabl = iv - 1
      else
        ivtabl = iv
      endif
      return
      END
c     ----------------------------------------------------------------- 
      SUBROUTINE DqlInit
c     initialize d quasilinear constants
#include "Implic.inc"
#include "params.inc"
#include "DqlBins.inc"
#include "RayWrk.inc"
#include "FeBins.inc"
#include "PIetc.inc"
#include "CGSetc.inc"
#include "MKSetc.inc"
      REAL
     ^     EcgsbyEmks
      DATA EcgsbyEmks / 3.333333e-5 /
c     Valeo original:
c     DqlNorm = (PI / 2.) * ((ECHARG / EMASS) ** 2) * EcgsbyEmks *
c    ^     EcgsbyEmks / (omega * omega) * (3.e10)
c     see Valeo-Eder, Eq. (22)
c     but why did he have omega twice
c     Here is an MKS version based on 
c     Dql = \Sigma (\pi/2) q^2/m^2 E_z^2 /({\Delta k_\parallel} v_\parallel) 
c         = \Sigma (\pi/2) q^2/m^2 E_z^2 / omega * v/delta-v
c         = \Sigma DqlNorm E_z^2 /(v/c *delta-n)
      DqlNorm = (PI/2.) * (ECOULB/ELECMS)**2 * 1.0e24 / omega
c     Now divide out c^2
      DqlNorm = DqlNorm / (CLIGHT * 1.0e08)**2
      return
      END

      SUBROUTINE convolve(n, nsm, smvec, vout, vin)
#include "Implic.inc"
      INTEGER n, nsm, i, j, ilow, iup, jlow, jup
      REAL
     ^     smvec(-nsm : nsm), vout(n), vin(n)
c
c     convolute source vin with smvec to yield vout
c
c     interior points
      ilow = nsm + 1
      iup = n - nsm
      jlow = - nsm
      jup = nsm
      do 20 i = ilow, iup
         vout(i) = 0.
         do 10 j = jlow, jup
            vout(i) = vout(i) + smvec(j) * vin(i - j)
 10      continue
 20   continue
c
c     lower boundary
      ilow = 1
      iup = nsm
      jlow = - nsm
      do 40 i = ilow, iup
         vout(i) = 0.
         jup = i - 1
         do 30 j = jlow, jup
            vout(i) = vout(i) + smvec(j) * vin(i - j)
 30      continue
 40   continue
c
c     upper boundary
      ilow = n - nsm + 1
      iup = n
      jup = nsm
      do 60 i = ilow, iup
         vout(i) = 0.
         jlow = n - i
         do 50 j = jlow, jup
            vout(i) = vout(i) + smvec(j) * vin(i - j)
 50      continue
 60   continue
c
      return
      END

c                                                                      |
c                                                                      |
c     ql.f(or)  ends                        ---------------------------|

